diff -bruN freeswan-1.9.orig/pluto/kernel.c freeswan-1.9/pluto/kernel.c
--- freeswan-1.9.orig/pluto/kernel.c	Mon Jan 29 01:20:43 2001
+++ freeswan-1.9/pluto/kernel.c	Thu Jun  7 12:02:17 2001
@@ -1099,58 +1387,275 @@
 	passert(FALSE);	/* no transform at all! */
     }
 
-    set_text_said(text_said, &c->that.host_addr, inner_spi, inner_proto);
+    return eroute_connection(c
+       , inner_spi, inner_proto, inner_satype
+       , op, opname);
+}
+
+/* Add/replace/delete a shunt eroute.
+ * Such an eroute determines the fate of packets without the use
+ * of any SAs.  These are defaults, in effect.
+ * If a negotiation has not been attempted, use TRAP.
+ * If negotiation has failed, the choice between TRAP/PASS/DROP/REJECT
+ * is specified in the policy of connection c.
+ */
+static bool
+shunt_eroute(struct connection *c, unsigned int op, const char *opname)
+{
+    /* We are constructing a special SAID for the eroute.
+     * The destination doesn't seem to matter, but the family does.
+     * The protocol is SA_INT -- mark this as shunt.
+     * The satype has no meaning, but is required for PF_KEY header!
+     * The SPI signifies the kind of shunt.
+     */
+
+    /* note: these are in host order :-( */
+    static ipsec_spi_t shunt_spi[] = { SPI_TRAP /* */
+       , SPI_PASS      /* --pass */
+       , SPI_DROP      /* --drop */
+       , SPI_REJECT }; /* --pass --drop */
 
-    networkof(&c->this.client, &sflow_ska);
-    maskof(&c->this.client, &smask_ska);
+    ipsec_spi_t spi = c->routing == RT_ROUTED_PROSPECTIVE? SPI_TRAP
+       : shunt_spi[(c->policy & POLICY_OPPO_MASK) >> POLICY_OPPO_SHIFT];
 
-    networkof(&c->that.client, &dflow_ska);
-    maskof(&c->that.client, &dmask_ska);
+    return eroute_connection(c, htonl(spi), SA_INT, SADB_X_SATYPE_INT, op, opname);
+}
 
-    DBG(DBG_CONTROL,
+/* scan /proc/net/ipsec_eroute every once in a while, looking for:
+ *
+ * - HOLD shunts of which Pluto isn't aware.  This situation could
+ *   be caused by lost ACQUIRE messages.  When found, they will
+ *   added to orphan_holds.  This in turn will lead to Opportunistic
+ *   initiation.
+ *
+ * - PASS shunts that haven't been used recently.  These will be
+ *   deleted.
+ *
+ * - (eventually) other shunt eroutes that haven't been used in a while.
+ *
+ * Here are some sample lines:
+ *  10.3.2.1.0/24    -> 0.0.0.0/0          => int0x104@0.0.0.0
+ *  10.3.2.1.115/32  -> 10.19.75.161/32  => tun0x1002@10.19.75.145
+ *  10.44.73.97/32   -> 0.0.0.0/0          => int0x104@0.0.0.0
+ *  10.44.73.97/32   -> 10.114.121.41.23/32   => int0x100@10.114.121.41.23
+ * Newer versions of KLIPS start each line with a 32-bit packet count.
+ * If available, these counts are used to detect
+ */
+void
+scan_proc_shunts(void)
+{
+    static const char procname[] = "/proc/net/ipsec_eroute";
+    FILE *f;
+    time_t nw = now();
+    int lino;
+    struct eroute_info *expired = NULL;
+
+    event_schedule(EVENT_SHUNT_SCAN, SHUNT_SCAN_INTERVAL, NULL);
+
+    /* free any leftover entries: they will be refreshed if still current */
+    while (orphaned_holds != NULL)
 	{
-	    char mybuf[SUBNETTOT_BUF];
-	    char peerbuf[SUBNETTOT_BUF];
+       struct eroute_info *p = orphaned_holds;
 
-	    subnettot(&c->this.client, 0, mybuf, sizeof(mybuf));
-	    subnettot(&c->that.client, 0, peerbuf, sizeof(peerbuf));
-	    DBG_log("%s eroute %s to %s via %s"
-		, opname, mybuf, peerbuf, text_said);
-	});
+       orphaned_holds = p->next;
+       pfree(orphaned_holds);
+    }
 
-    return pfkey_msg_start(op & ~ERO_REPLACE_FLAG, inner_satype
-	, "pfkey_msg_hdr flow", text_said, extensions)
+    /* decode the /proc file.  Don't do anything strenuous to it
+     * (certainly no PF_KEY stuff) to minimize the chance that it
+     * might change underfoot.
+     */
 
-    && (op == ERO_DELETE
-	|| (pfkey_build(pfkey_sa_build(&extensions[SADB_EXT_SA]
-	    	, SADB_EXT_SA
-		, inner_spi	/* in network order */
-	    	, 0, 0, 0, 0, op == ERO_REPLACE? SADB_X_SAFLAGS_REPLACEFLOW : 0)
-	    , "pfkey_sa add flow", text_said, extensions)
+    f = fopen(procname, "r");
+    if (f == NULL)
+       return;
 
-	    && pfkeyext_address(SADB_EXT_ADDRESS_SRC, &c->this.host_addr
-		, "pfkey_addr_s add flow", text_said, extensions)
+    /* for each line... */
+    for (lino = 1; ; lino++)
+    {
+       unsigned char buf[1024];        /* should be big enough */
+       chunk_t field[10];      /* 10 is loose upper bound */
+       chunk_t *ff;    /* fixed fields (excluding optional count) */
+       int fi;
+       struct eroute_info eri;
+       char *cp;
+       err_t context = ""
+           , ugh = NULL;
 
-	    && pfkeyext_address(SADB_EXT_ADDRESS_DST, &c->that.host_addr
-		, "pfkey_addr_d add flow", text_said, extensions)))
+       cp = fgets(buf, sizeof(buf), f);
+       if (cp == NULL)
+           break;
 
-    && pfkeyext_address(SADB_X_EXT_ADDRESS_SRC_FLOW, &sflow_ska
-	, "pfkey_addr_sflow", text_said, extensions)
+       /* break out each field
+        * Note: if there are too many fields, just stop;
+        * it will be diagnosed a little later.
+        */
+       for (fi = 0; fi < (int)elemsof(field); fi++)
+	{
+           static const char sep[] = " \t\n";  /* field-separating whitespace */
+           size_t w;
+
+           cp += strspn(cp, sep);      /* find start of field */
+           w = strcspn(cp, sep);       /* find width of field */
+           setchunk(field[fi], cp, w);
+           cp += w;
+           if (w == 0)
+               break;
+       }
 
-    && pfkeyext_address(SADB_X_EXT_ADDRESS_DST_FLOW, &dflow_ska
-	, "pfkey_addr_dflow", text_said, extensions)
+       /* This odd do-hickey is to share error reporting code.
+        * A break will get to that common code.  The setting
+        * of "ugh" and "context" parameterize it.
+        */
+       do {
+           /* Old entries have no packet count; new ones do.
+            * check if things are as they should be.
+            */
+           if (fi == 5)
+               ff = &field[0]; /* old form, with no count */
+           else if (fi == 6)
+               ff = &field[1]; /* new form, with count */
+           else
+           {
+               ugh = "has wrong number of fields";
+               break;
+           }
 
-    && pfkeyext_address(SADB_X_EXT_ADDRESS_SRC_MASK, &smask_ska
-	, "pfkey_addr_smask", text_said, extensions)
+           if (ff[1].len != 2
+           || strncmp(ff[1].ptr, "->", 2) != 0
+           || ff[3].len != 2
+           || strncmp(ff[3].ptr, "=>", 2) != 0)
+           {
+               ugh = "is missing -> or =>";
+               break;
+           }
 
-    && pfkeyext_address(SADB_X_EXT_ADDRESS_DST_MASK, &dmask_ska
-	, "pfkey_addr_dmask", text_said, extensions)
+           /* actually digest fields of interest */
 
-    && finish_pfkey_msg(extensions, "flow", text_said, NULL);
+           /* packet count */
+
+           eri.count = 0;
+           if (ff != field)
+           {
+               context = "count field is malformed: ";
+               ugh = ttoul(field[0].ptr, field[0].len, 10, &eri.count);
+               if (ugh != NULL)
+                   break;
+           }
+
+           /* our client */
+
+           context = "source subnet field malformed: ";
+           ugh = ttosubnet(ff[0].ptr, ff[0].len, AF_INET, &eri.ours);
+           if (ugh != NULL)
+               break;
+
+           /* his client */
+
+           context = "source subnet field malformed: ";
+           ugh = ttosubnet(ff[2].ptr, ff[2].len, AF_INET, &eri.his);
+           if (ugh != NULL)
+               break;
+
+           /* SAID */
+
+           context = "SA ID field malformed: ";
+           ugh = ttosa(ff[4].ptr, ff[4].len, &eri.said);
+       } while (FALSE);
+
+       if (ugh != NULL)
+       {
+           log("INTERNAL ERROR: %s line %d %s%s"
+               , procname, lino, context, ugh);
+           continue;   /* ignore rest of line */
+       }
+
+       /* Now we have decoded eroute, let's consider it.
+        * We only care about shunt eroutes.
+        *
+        * HOLD: if not known, add to orphaned_holds list for initiation
+        *    because ACQUIRE might have been lost.
+        *
+        * PASS: determine if idle; if so, blast it away.
+        *    Can occur bare (if DNS provided insufficient information)
+        *    or with a connection (failure context).
+        *    Could even be installed by ipsec manual.
+        *
+        * TRAP: always welcome.
+        *
+        * others: handling as yet undesigned.  Generally associated
+        *    with a failure context.
+        */
+       if (eri.said.proto == SA_INT)
+       {
+           switch (ntohl(eri.said.spi))
+           {
+           case SPI_HOLD:
+               if (bare_shunt_ptr(&eri.ours, &eri.his) == NULL
+               && shunt_owner(&eri.ours, &eri.his) == NULL)
+               {
+                   eri.next = orphaned_holds;
+                   orphaned_holds = clone_thing(eri, "orphaned HOLD");
+               }
+               break;
+
+           case SPI_PASS:
+               /* nothing sensible to do if we don't have counts */
+               if (ff != field)
+               {
+                   struct bare_shunt **bs_pp
+                       = bare_shunt_ptr(&eri.ours, &eri.his);
+
+                   if (bs_pp != NULL)
+                   {
+                       struct bare_shunt *bs = *bs_pp;
+
+                       if (eri.count != bs->count)
+                       {
+                           bs->count = eri.count;
+                           bs->last_activity = nw;
+                       }
+                       else if (nw - bs->last_activity > SHUNT_PATIENCE)
+                       {
+                           eri.next = expired;
+                           expired = clone_thing(eri, "expired PASS");
+                       }
+                   }
+               }
+               break;
+
+           case SPI_DROP:
+           case SPI_REJECT:
+           case SPI_TRAP:
+               break;
+
+           default:
+               passert(FALSE);
+           }
+       }
+    }  /* for each line */
+    fclose(f);
+
+    /* Now that we've finished processing the /proc file,
+     * it is safe to delete the expired PASS shunts.
+     */
+    while (expired != NULL)
+    {
+       struct eroute_info *p = expired;
+       ip_address src, dst;
+
+       networkof(&p->ours, &src);
+       networkof(&p->his, &dst);
+       (void) replace_bare_shunt(&src, &dst
+           , SPI_PASS, FALSE, "delete expired PASS");
+       expired = p->next;
+       pfree(p);
+    }
 }
 
 static bool
-del_spi(ipsec_spi_t spi, int proto, ip_address *src, ip_address *dest)
+del_spi(ipsec_spi_t spi, int proto
+, const ip_address *src, const ip_address *dest)
 {
     struct sadb_ext *extensions[SADB_EXT_MAX + 1];
     char text_said[SATOT_BUF];
@@ -1570,30 +2075,24 @@
 	passert(FALSE);	/* neither AH nor ESP in outbound SA bundle! */
     }
 
+    send_delete(st, &f->our_spi, proto==SA_ESP?TRUE:FALSE);
+
     return inbound
 	? del_spi(f->our_spi, proto, &c->that.host_addr, &c->this.host_addr)
 	: del_spi(f->attrs.spi, proto, &c->this.host_addr, &c->that.host_addr);
 }
-
-/* demand that we can eroute */
-static bool
-could_eroute(struct connection *c, struct connection *ero)
-{
-    if (ero != NULL && ero != c && ero->eroute_owner != SOS_NOBODY)
-    {
-	loglog(RC_LOG_SERIOUS, "cannot install eroute -- it is in use for \"%s\"", ero->name);
-	return FALSE;	/* another connection already using the eroute */
-    }
-    return TRUE;
-}
 #endif /* KLIPS */
 
 
-void init_kernel(void)
+void
+init_kernel(void)
 {
 #ifdef KLIPS
     if (!no_klips)
+    {
 	init_pfkey();
+	event_schedule(EVENT_SHUNT_SCAN, SHUNT_SCAN_INTERVAL, NULL);
+    }
 #endif
 }
 
@@ -1612,112 +2111,199 @@
      * obsolete and should be eliminated.  Interestingly, this is
      * the only case in which we can tell that a connection is obsolete.
      */
-    if (!subnetishost(&c->that.client))
+    passert(c->kind != CK_TEMPLATE);
+    if (c->that.has_client)
     {
 	for (;;)
 	{
-	    struct connection *o = route_owner(c, FALSE);
+	    struct connection *o = route_owner(c, NULL);
 
 	    if (o == NULL)
 		break;	/* nobody has a route */
 
-	    if (sameaddr(&o->this.host_addr, &c->this.host_addr)
-	    && sameaddr(&o->that.host_addr, &c->that.host_addr))
+           /* note: we ignore the client addresses at this end */
+           if (sameaddr(&o->that.host_addr, &c->that.host_addr)
+           && o->interface == c->interface)
 		break;	/* existing route is compatible */
 
-	    loglog(RC_LOG_SERIOUS, "route to peer's client conflicts with \"%s\" %s; unorienting old connection to free the route"
+	    loglog(RC_LOG_SERIOUS, "route to peer's client conflicts with \"%s\" %s; releasing old connection to free the route"
 		, o->name, ip_str(&o->that.host_addr));
-	    unorient_connection(o);
+	    release_connection(o);
 	}
     }
-#ifdef KLIPS
-    /* check that we will be able to eroute */
-    if (!could_eroute(c, route_owner(c, TRUE)))
-	return FALSE;
-
-    /* Check that we will be able to route outgoing packets
-     * through ipsecN interface.  Actually, this only checks that
-     * our peer isn't inside his own subnet or if she is,
-     * that we're using UDP 500 so that IKE messages will not
-     * be processed.
-     */
-    if (!route_connection(c, FALSE))
+    /* check that we will be able to route and eroute */
+    if (!could_route(c))
 	return FALSE;
 
+#ifdef KLIPS
     /* (attempt to) actually set up the SAs */
     return setup_half_ipsec_sa(st, TRUE);
-
 #else /* !KLIPS */
     DBG(DBG_CONTROL, DBG_log("install_inbound_ipsec_sa()"));
     return TRUE;
 #endif /* !KLIPS */
 }
 
-bool
-install_ipsec_sa(struct state *st, bool inbound_also)
+/* Install a route and then a prospective shunt eroute or an SA group eroute.
+ * Assumption: could_route gave a go-ahead.
+ * Any SA Group must have already been created.
+ * On failure, steps will be unwound (where feasible: old shunt
+ * will be lost -- this may matter).
+ */
+static bool
+route_and_eroute(struct connection *c, struct state *st)
 {
 #ifdef KLIPS
-    bool res;
-    struct connection
-	*c = st->st_connection,
-	*ero = route_owner(c, TRUE);	/* who, if anyone, owns our eroute? */
+    struct connection *ero     /* who, if anyone, owns our eroute? */
+       , *ro = route_owner(c, &ero);
+    bool eroute_installed = FALSE
+       , firewall_notified = FALSE
+       , route_installed = FALSE;
+
+    /* install the eroute */
+
+    passert(ero == NULL || ero == c);
+    if (ero != NULL)
+    {
+       /* We're replacing an eroute */
+       eroute_installed = st == NULL
+           ? shunt_eroute(c, ERO_REPLACE, "replace")
+           : sag_eroute(st, ERO_REPLACE, "replace");
+    }
+    else
+    {
+       /* we're adding an eroute */
+       eroute_installed = st == NULL
+           ? shunt_eroute(c, ERO_ADD, "add")
+           : sag_eroute(st, ERO_ADD, "add");
+    }
 
-    if (!could_eroute(c, ero))
-	return FALSE;
+    /* notify the firewall of a new tunnel */
 
-    /* route outgoing packets through ipsecN interface.
-     * Note that we don't bother to undo this on failure.
+    if (eroute_installed)
+    {
+       /* do we have to notify the firewall?  Yes, if it wasn't notified
+        * for a previous tunnel with the same clients.  Any Previous
+        * tunnel would have to be for our connection, so the actual
+        * test is simple.
      */
-    if (!route_connection(c, TRUE))
-	return FALSE;
+       firewall_notified = c->eroute_owner != SOS_NOBODY
+           || do_command(c, "up");
+    }
 
-    /* (attempt to) actually set up the SAs */
-    res = (!inbound_also || setup_half_ipsec_sa(st, TRUE))
-	&& setup_half_ipsec_sa(st, FALSE);
+    /* install the route */
 
-    /* no other connection has this eroute, but
-     * this connection might have it for another SA.
-     * This is expected when rekeying.
-     * If another SA has it, we replace the eroute.
-     */
-    if (res)
+    if (!firewall_notified)
     {
-	/* succeed OR tear SA down again */
-	if (c->eroute_owner == SOS_NOBODY)
+       /* we're in trouble -- don't do routing */
+    }
+    else if (ro == NULL)
 	{
-	    /* new eroute: we also need to run "up" command */
-	    res = do_eroute(st, ERO_ADD, "add");
-	    if (res)
+       /* a new route: no deletion required, but preparation is */
+       (void) do_command(c, "prepare");        /* just in case; ignore failure */
+       route_installed = do_command(c, "route");
+    }
+    else if (routed(c->routing)
+    || routes_agree(ro, c))
 	    {
-		/* succeed OR tear eroute down again */
-		res = do_command(st->st_connection, "up");
-		if (!res)
-		    (void) do_eroute(st, ERO_DELETE, "delete");
+       route_installed = TRUE; /* nothing to be done */
 	    }
+    else
+    {
+       /* Some other connection must own the route
+        * and the route must disagree.  But since could_route
+        * must have allowed our stealing it, we'll do so.
+        *
+        * A feature of LINUX allows us to install the new route
+        * before deleting the old if the nexthops differ.
+        * This reduces the "window of vulnerability" when packets
+        * might flow in the clear.
+        */
+       if (sameaddr(&c->this.host_nexthop, &ro->this.host_nexthop))
+	{
+           (void) do_command(ro, "unroute");
+           route_installed = do_command(c, "route");
 	}
 	else
 	{
-	    /* old eroute being replaced -- no command required */
-	    res = do_eroute(st, ERO_REPLACE, "replace");
+           route_installed = do_command(c, "route");
+           (void) do_command(ro, "unroute");
 	}
-	if (res)
+
+       /* record unrouting */
+       if (route_installed)
+	{
+           do {
+               passert(!erouted(ro->routing));
+               ro->routing = RT_UNROUTED;
+               ro = route_owner(c, NULL);      /* no need to keep old value */
+           } while (ro != NULL);
+       }
+    }
+
+    /* all done -- clean up */
+    if (route_installed)
+    {
+       /* Success! */
+       if (st == NULL)
+       {
+           c->routing = RT_ROUTED_PROSPECTIVE;
+	}
+	else
 	{
+           c->routing = RT_ROUTED_TUNNEL;
 	    c->eroute_owner = st->st_serialno;
 	}
+
+       return TRUE;
+    }
 	else
 	{
-	    (void) teardown_half_ipsec_sa(st, FALSE);
-	    if (inbound_also)
-		(void) teardown_half_ipsec_sa(st, TRUE);
+       /* Failure!  Unwind our work. */
+       if (firewall_notified && c->eroute_owner == SOS_NOBODY)
+           (void) do_command(c, "down");
+
+       if (eroute_installed)
+       {
+           if (st == NULL)
+               (void) shunt_eroute(c, ERO_DELETE, "delete");
+           else
+               (void) sag_eroute(st, ERO_DELETE, "delete");
 	}
+
+       return FALSE;
     }
+#else /* !KLIPS */
+    return TRUE;
+#endif /* !KLIPS */
+}
 
-    return res;
+bool
+install_ipsec_sa(struct state *st, bool inbound_also)
+{
+    if (!could_route(st->st_connection))
+       return FALSE;
+
+#ifdef KLIPS
+    /* (attempt to) actually set up the SA group */
+    if ((inbound_also && !setup_half_ipsec_sa(st, TRUE))
+    || !setup_half_ipsec_sa(st, FALSE))
+       return FALSE;
+
+    if (!route_and_eroute(st->st_connection, st))
+    {
+       (void) delete_ipsec_sa(st, FALSE);
+       return FALSE;
+    }
 #else /* !KLIPS */
+    if (!could_route(st->st_connection))
+       return FALSE;
+
     DBG(DBG_CONTROL, DBG_log("install_ipsec_sa() %s"
 	, inbound_also? "inbound and oubound" : "outbound only"));
-    return route_connection(st->st_connection, TRUE);
 #endif /* !KLIPS */
+
+    return TRUE;
 }
 
 bool
@@ -1736,10 +2322,16 @@
     {
 	if (own_eroute)
 	{
-	    res = do_command(st->st_connection, "down")
-		&& do_eroute(st, ERO_DELETE, "delete");
-	    if (res)
 		c->eroute_owner = SOS_NOBODY;
+           c->routing = RT_ROUTED_PROSPECTIVE;
+           res = do_command(c, "down")
+               && shunt_eroute(c, ERO_REPLACE, "replace with shunt");
+           if (!res)
+           {
+               /* since we failed, restore our record of routing */
+               c->eroute_owner = st->st_serialno;
+               c->routing = RT_ROUTED_TUNNEL;
+           }
 	}
 	if (res)
 	    res = teardown_half_ipsec_sa(st, FALSE)
@@ -1748,7 +2340,7 @@
 
     return res;
 #else /* !KLIPS */
-    DBG(DBG_CONTROL, DBG_log("if I knew how, I'd do_eroute() and teardown_ipsec_sa()"));
+    DBG(DBG_CONTROL, DBG_log("if I knew how, I'd eroute() and teardown_ipsec_sa()"));
     return TRUE;
 #endif /* !KLIPS */
 }
diff -bruN freeswan-1.9.orig/pluto/kernel.h freeswan-1.9/pluto/kernel.h
--- freeswan-1.9.orig/pluto/kernel.h	Tue Jan 23 18:09:30 2001
+++ freeswan-1.9/pluto/kernel.h	Wed Jun  6 12:57:42 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: kernel.h,v 1.18 2001/01/23 23:09:30 dhr Exp $
+ * RCSID $Id: kernel.h,v 1.23 2001/05/28 19:18:19 dhr Exp $
  */
 
 extern bool no_klips;	/* don't actually use KLIPS */
@@ -25,11 +25,20 @@
 
 extern void init_kernel(void);
 
+extern void scan_proc_shunts(void);
+
 extern void pfkey_event(void);
 
 struct connection;	/* forward declaration of tag */
-extern bool route_connection(struct connection *c, bool doit);
+extern bool trap_connection(struct connection *c);
 extern void unroute_connection(struct connection *c);
+
+extern bool replace_bare_shunt(const ip_address *src, const ip_address *dst
+    , ipsec_spi_t shunt_spi    /* in host order! */
+    , bool repl, const char *opname);
+
+extern bool assign_hold(struct connection *c
+    , const ip_address *src, const ip_address *dst);
 
 struct state;	/* forward declaration of tag */
 extern ipsec_spi_t get_ipsec_spi(ipsec_spi_t avoid);
diff -bruN freeswan-1.9.orig/pluto/kernel_comm.c freeswan-1.9/pluto/kernel_comm.c
--- freeswan-1.9.orig/pluto/kernel_comm.c	Tue Jan 23 18:09:30 2001
+++ freeswan-1.9/pluto/kernel_comm.c	Wed Jun  6 13:36:22 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: kernel_comm.c,v 1.53 2001/01/23 23:09:30 dhr Exp $
+ * RCSID $Id: kernel_comm.c,v 1.61 2001/05/29 18:39:57 dhr Exp $
  */
 
 #include <stdio.h>
@@ -46,9 +46,8 @@
 
 /* helper variables and function to decode strings from whack message */
 
-static char
-    *next_str,
-    *str_roof;
+static char *next_str
+    , *str_roof;
 
 static bool
 unpack_str(char **p)
@@ -96,22 +95,19 @@
 
     /* sanity check message */
     {
-	int ughno = RC_BADWHACKMESSAGE;
-	char ugh[200];	/* sufficient for our messages (we hope) */
+	err_t ugh = NULL;
 
 	next_str = msg.string;
 	str_roof = (char *)&msg + n;
 
 	if (next_str > str_roof)
 	{
-	    snprintf(ugh, sizeof(ugh)
-		, "truncated message from whack: got %d bytes; expected %d.  Message ignored."
+		ugh = builddiag("truncated message from whack: got %d bytes; expected %d.  Message ignored."
 		, n, (int) sizeof(msg));
 	}
 	else if (msg.magic != WHACK_MAGIC)
 	{
-	    snprintf(ugh, sizeof(ugh)
-		, "message from whack has bad magic %d; should be %d; probably wrong version.  Message ignored"
+		ugh = builddiag("message from whack has bad magic %d; should be %d; probably wrong version.  Message ignored"
 		, msg.magic, WHACK_MAGIC);
 	}
 	else if (!unpack_str(&msg.name)	/* string 1 */
@@ -122,18 +118,16 @@
 	|| !unpack_str(&msg.keyid)	/* string 6 */
 	|| str_roof - next_str != (ptrdiff_t)msg.keyval.len)	/* check chunk */
 	{
-	    snprintf(ugh, sizeof(ugh)
-		, "message from whack contains bad string");
+	    ugh = "message from whack contains bad string";
 	}
 	else
 	{
 	    msg.keyval.ptr = next_str;	/* grab chunk */
-	    ughno = 0;	/* ran through the gauntlet -- success */
 	}
 
-	if (ughno != 0)
+	if (ugh != NULL)
 	{
-	    loglog(ughno, "%s", ugh);
+	    loglog(RC_BADWHACKMESSAGE, "%s", ugh);
 	    whack_log_fd = NULL_FD;
 	    close(whackfd);
 	    return;
@@ -149,8 +143,8 @@
 	     * cause the message to print, it will be printed.
 	     */
 	    cur_debugging |= msg.debugging;
-	    DBG(DBG_CONTROL,
-		DBG_log("base debugging = %s"
+	    DBG(DBG_CONTROL
+		, DBG_log("base debugging = %s"
 		    , bitnamesof(debug_bit_names, msg.debugging)));
 	    cur_debugging = base_debugging = msg.debugging;
 	}
@@ -161,8 +155,8 @@
 	    if (c != NULL)
 	    {
 		c->extra_debugging = msg.debugging;
-		DBG(DBG_CONTROL,
-		    DBG_log("\"%s\" extra_debugging = %s"
+		DBG(DBG_CONTROL
+		    , DBG_log("\"%s\" extra_debugging = %s"
 			, c->name
 			, bitnamesof(debug_bit_names, c->extra_debugging)));
 	    }
@@ -244,9 +238,10 @@
 	    if (c != NULL)
 	    {
 		SET_CUR_CONNECTION(c);
-		if (!orient(c, TRUE))
-		    whack_log(RC_ORIENT, "could not orient connection");
-		else if (!route_connection(c, TRUE))
+               if (!oriented(*c))
+                   whack_log(RC_ORIENT
+                       , "we have no ipsecN interface for either end of this connection");
+               else if (!trap_connection(c))
 		    whack_log(RC_ROUTE, "could not route");
 		UNSET_CUR_CONNECTION();
 	    }
@@ -260,7 +255,7 @@
 	if (c != NULL)
 	{
 	    SET_CUR_CONNECTION(c);
-	    if (c->eroute_owner != SOS_NOBODY)
+	    if (c->routing >= RT_ROUTED_TUNNEL)
 		whack_log(RC_RTBUSY, "cannot unroute: route busy");
 	    else
 		unroute_connection(c);
@@ -283,6 +278,7 @@
 	    whack_log(RC_DEAF, "need --listen before opportunistic initiation");
 	else
 	    initiate_opportunistic(&msg.oppo_my_client, &msg.oppo_peer_client
+		, FALSE
 		, msg.whack_async? NULL_FD : dup_any(whackfd));
     }
 
@@ -291,6 +287,8 @@
 
     if (msg.whack_status)
     {
+	show_ifaces_status();
+	whack_log(RC_COMMENT, BLANK_FORMAT);    /* spacer */
 	show_connections_status();
 	whack_log(RC_COMMENT, BLANK_FORMAT);	/* spacer */
 	show_states_status();
diff -bruN freeswan-1.9.orig/pluto/log.c freeswan-1.9/pluto/log.c
--- freeswan-1.9.orig/pluto/log.c	Tue Sep 12 02:59:29 2000
+++ freeswan-1.9/pluto/log.c	Wed Jun  6 16:40:09 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: log.c,v 1.34 2000/09/12 06:59:29 dhr Exp $
+ * RCSID $Id: log.c,v 1.38 2001/05/05 17:20:01 dhr Exp $
  */
 
 #include <stdio.h>
@@ -279,13 +279,49 @@
 	len = strlen(m);
 	m[len] = '\n';	/* don't need NUL, do need NL */
 
+	/* write to whack socket, but ignore any SIGPIPE that results */
 	{
-	    void (*old_sigpipe)(int) = signal(SIGPIPE, SIG_IGN);
+           int r;
+           struct sigaction act
+               , oldact;
+
+           act.sa_handler = SIG_IGN;
+           sigemptyset(&act.sa_mask);
+           act.sa_flags = 0;   /* no nothing */
+           r = sigaction(SIGPIPE, &act, &oldact);
+           passert(r == 0);
 
-	    write(wfd, m, len + 1);
-	    signal(SIGPIPE, old_sigpipe);
+           (void) write(wfd, m, len + 1);
+
+           r = sigaction(SIGPIPE, &oldact, NULL);
+           passert(r == 0);
 	}
     }
+}
+
+/* Build up a diagnostic in a static buffer.
+ * Although this would be a generally useful function, it is very
+ * hard to come up with a discipline that prevents different uses
+ * from interfering.  It is intended that by limiting it to building
+ * diagnostics, we will avoid this problem.
+ * Juggling is performed to allow an argument to be a previous
+ * result: the new string may safely depend on the old one.  This
+ * restriction is not checked in any way: violators will produce
+ * confusing results (without crashing!).
+ */
+err_t
+builddiag(const char *fmt, ...)
+{
+    static char msg[1024];     /* longer messages will be truncated */
+    char t[sizeof(msg)];       /* build result here first */
+    va_list args;
+
+    va_start(args, fmt);
+    t[0] = '\0';       /* in case nothing terminates string */
+    vsnprintf(t, sizeof(t), fmt, args);
+    va_end(args);
+    strcpy(msg, t);
+    return msg;
 }
 
 /* Debugging message support */
diff -bruN freeswan-1.9.orig/pluto/log.h freeswan-1.9/pluto/log.h
--- freeswan-1.9.orig/pluto/log.h	Tue Sep 12 02:59:29 2000
+++ freeswan-1.9/pluto/log.h	Wed Jun  6 13:41:37 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: log.h,v 1.23 2000/09/12 06:59:29 dhr Exp $
+ * RCSID $Id: log.h,v 1.26 2001/05/05 17:20:01 dhr Exp $
  */
 
 #include <freeswan.h>
@@ -96,6 +96,18 @@
  * Much like log, actually, except for specifying mess_no.
  */
 extern void loglog(int mess_no, const char *message, ...) PRINTF_LIKE(2);
+
+/* Build up a diagnostic in a static buffer.
+ * Although this would be a generally useful function, it is very
+ * hard to come up with a discipline that prevents different uses
+ * from interfering.  It is intended that by limiting it to building
+ * diagnostics, we will avoid this problem.
+ * Juggling is performed to allow an argument to be a previous
+ * result: the new string may safely depend on the old one.  This
+ * restriction is not checked in any way: violators will produce
+ * confusing results (without crashing!).
+ */
+extern err_t builddiag(const char *fmt, ...) PRINTF_LIKE(1);
 
 #ifdef DEBUG
 
diff -bruN freeswan-1.9.orig/pluto/main.c freeswan-1.9/pluto/main.c
--- freeswan-1.9.orig/pluto/main.c	Tue Jan 23 18:09:31 2001
+++ freeswan-1.9/pluto/main.c	Wed Jun  6 13:42:06 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: main.c,v 1.40 2001/01/23 23:09:31 dhr Exp $
+ * RCSID $Id: main.c,v 1.41 2001/03/13 09:22:05 dhr Exp $
  */
 
 #include <stdio.h>
@@ -29,6 +29,11 @@
 
 #include <freeswan.h>
 
+#ifdef OPENSSL
+#include <openssl/evp.h>
+#include <openssl/err.h>
+#endif
+
 #include "constants.h"
 #include "defs.h"
 #include "id.h"
@@ -42,6 +47,20 @@
 #include "rnd.h"
 #include "state.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#include "xmap_dir.h"
+#include "xmap_file.h"
+#ifdef HAVE_DB
+#include "xmap_db.h"
+#endif
+#ifdef HAVE_LDAP
+#include "xmap_ldap.h"
+#endif
+#include "xmap.h"
+
+#endif /* OPENSSL */
+
 #include "sha1.h"
 #include "md5.h"
 #include "crypto.h"	/* requires sha1.h and md5.h */
@@ -158,6 +177,21 @@
     bool log_to_stderr_desired = FALSE;
     int lockfd;
 
+#ifdef OPENSSL
+    SSLeay_add_all_algorithms();
+    X509V3_add_standard_extensions();
+    ERR_load_crypto_strings();
+    ERR_load_ElGamal_strings();
+    XMAP_register(XMAP_METHOD_file());
+    XMAP_register(XMAP_METHOD_dir());
+#ifdef HAVE_DB
+    XMAP_register(XMAP_METHOD_db());
+#endif /* HAVE_DB */
+#ifdef HAVE_LDAP
+    XMAP_register(XMAP_METHOD_ldap());
+#endif /* HAVE_LDAP */
+#endif
+
     /* handle arguments */
     for (;;)
     {
@@ -384,6 +418,7 @@
 
     close(lockfd);
 
+    init_constants();
     init_log();
     /* Note: some scripts may look for this exact message -- don't change */
     log("Starting Pluto (FreeS/WAN Version %s)", freeswan_version);
@@ -417,6 +452,10 @@
 #ifdef LEAK_DETECTIVE
     report_leaks();
 #endif /* LEAK_DETECTIVE */
+#ifdef OPENSSL
+    X509V3_EXT_cleanup();
+    ERR_free_strings();
+#endif
     close_log();
     exit(status);
 }
